<?php

declare(strict_types=1);

namespace Seka\Terminy\Mail\Udalost;

use Illuminate\Support\Str;
use Illuminate\Mail\Mailable;
use Illuminate\Bus\Queueable;
use Seka\Terminy\Dtos\UdalostDTO;
use Elceka\Laravel\HashId\Hasher;
use Illuminate\Support\Facades\URL;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

/**
 * Class ZverejnenaNovaUdalostMail
 *
 * @package Seka\Terminy\Mail\Udalost
 */
final class ZverejnenaNovaUdalostMail extends Mailable implements ShouldQueue
{
    use Queueable;
    use SerializesModels;

    /**
     * @var \Seka\Terminy\Dtos\UdalostDTO
     */
    public UdalostDTO $udalost;

    /**
     * ZverejnenaNovaUdalostMail constructor.
     *
     * @param \Seka\Terminy\Dtos\UdalostDTO $udalost
     */
    public function __construct(UdalostDTO $udalost)
    {
        $this->udalost = $udalost;
    }

    /**
     * @return mixed
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function build()
    {
        $urlUdalosti = URL::signedRoute(
            'modul.terminy.frontend.udalosti.udalost.show',
            [
                'mtUdalostId' => Hasher::encode($this->udalost->id)
            ]
        );

        return $this
            ->subject(Str::ucfirst($this->udalost->druh->label))
            ->markdown('Terminy::mail.udalost.public.zverejnena')
            ->withUdalost($this->udalost)
            ->withUrlUdalosti($urlUdalosti)
            ->replyTo(config('terminy.podpora.email'));
    }
}
